def naive_fibo(n):
    if n < 0:
        raise ValueError('Negative Fibonacci number?')
    if n==0:
        return 0
    elif n==1:
        return 1
    else:
        return naive_fibo(n-1) + naive_fibo(n-2)

known = {0:0, 1:1}
def fibo(n):
    if n in known:
        return known[n]
    else:
        f = fibo(n-1) + fibo(n-2)
        known[n] = f
        return(f)
